#include <stdio.h>
#include <stdlib.h>

typedef struct _arrplus {
    double *arr;
    int length;
} ArrayPlus;

void arpDelete(ArrayPlus *a) {
    if (a == NULL) {
        return;
    }

    if (a->arr != NULL) {
        free(a->arr);
    }

    free(a);
}

ArrayPlus *arpCreate(int size) {
    if (size < 0) {
        return NULL;
    }

    ArrayPlus *A = (ArrayPlus *)malloc( sizeof(ArrayPlus) );
    if (A == NULL) {
        return NULL;
    }

    A->length = size;
    A->arr = (double *)malloc( size * sizeof(double));
    if (A->arr == NULL) {
        arpDelete(A);
        return NULL;
    }

    return A;
}

ArrayPlus *arpCreateConstant(int size, double constant) {
    ArrayPlus *A = arpCreate(size);
    if (A == NULL) {
        return NULL;
    }
    for (int i = 0; i < A->length; ++i) {
        A->arr[i] = constant;
    }
}

ArrayPlus *arpCreateZeros(int size) {
    return arpCreateConstant(size, 0.0);
}

ArrayPlus *arpJoin(ArrayPlus *a, ArrayPlus *b) {
    if (a == NULL || b == NULL) {
        return NULL;
    }

    ArrayPlus *ab = arpCreate( a->length + b->length );
    if (ab == NULL) {
        return NULL;
    }

    int i;
    for (i = 0; i < a->length; ++i) {
        ab->arr[i] = a->arr[i];
    }
    for (int j = 0; j < b->length; ++j, ++i) {
        ab->arr[i] = b->arr[j];
    }

    return ab;
}

int main() {

}