#include <stdio.h>
#include <stdlib.h>
#include <string.h>

char **splitAt(char separator, char *text, int *N) {
    if (separator == 0 ||
        text == NULL ||
        N == NULL) {

        return NULL;
    }

    int length = strlen(text) + 1;
    char *copy = (char *)malloc(length * sizeof(char) );
    if (copy == NULL) {
        return NULL;
    }
    strcpy(copy, text);

    int phraseCount = 1;
    for (int i = 0; i < length; ++i) {
        if (copy[i] == separator) {
            copy[i] = 0;
            phraseCount++;
        }
    }

    char **phrases = (char **)malloc( phraseCount * sizeof(char *) );
    if (phrases == NULL) {
        free(copy);
        return NULL;
    }

    phrases[0] = copy;
    int currentPhrase = 0;
    for (int i = 0; i < length; ++i) {
        if (copy[i] == 0) {
            currentPhrase++;
            phrases[currentPhrase] = &copy[i+1];
        }
        if (currentPhrase == phraseCount-1) {
            break;
        }
    }

    *N = phraseCount;
    return phrases;
}

int main() {

}